// отработка получения кодов клавиш
void do_for_key(int mod,int kod)
 {
 if(mod==VIEW_MODE)
    do_for_key1(kod);
 else if(mod==EDIT_MODE)
    do_for_key2(kod);
 else if(mod==RUN_MODE)
    do_for_key3(kod);
 else if(mod==CALIB_MODE)
    do_for_key4(kod);
 else
    ;
 } 
// режим просмотра
void do_for_key1(int kod)
 {
 switch(kod)
   {
   case btn_VIEW_EDIT_RUN:   // вход в режим редактирования программы
        mode=EDIT_MODE;lcd_str1(mode);lcd_str2ve();
        break;  
   case btn_NEXT_PRG:   // следующая программа
        VIEW1.tek_prg=max((VIEW1.tek_prg+1)%(VIEW1.count_prg+1),1);
        //VIEW1.tek_prg=min(VIEW1.tek_prg+1,VIEW1.count_prg);
        get_prg_eeprom(VIEW1.tek_prg);
        //VIEW1.pos_prg=0;
        lcd_str1(mode);lcd_str2ve();
        break;  
   case btn_PREV_PRG:   // предыдущая программы
        VIEW1.tek_prg=VIEW1.tek_prg-1;
        if(VIEW1.tek_prg==0)
           VIEW1.tek_prg=VIEW1.count_prg;
        //VIEW1.tek_prg=max(VIEW1.tek_prg-1,1);
        get_prg_eeprom(VIEW1.tek_prg);
        //VIEW1.pos_prg=0;
        lcd_str1(mode);lcd_str2ve();
        break;  
   case btn_PREV_POS:   // предыдущий параметр текущей программы
        VIEW1.pos_prg=(VIEW1.pos_prg+9-1)%9;
        lcd_str2ve();
        break;  
   case btn_NEXT_POS:   // следующий параметр текущей программы
        VIEW1.pos_prg=(VIEW1.pos_prg+1)%9;
        lcd_str2ve();
        break;  
   case btn_ADD_PRG:   // добавление новой программы
        VIEW1.count_prg=VIEW1.count_prg+1;
        VIEW1.tek_prg=VIEW1.count_prg;
        set_count_prg_eeprom(VIEW1.count_prg,VIEW1.tek_prg);
        ini_eeprom(VIEW1.tek_prg);
        get_prg_eeprom(VIEW1.tek_prg);
        lcd_message1("new prg create");
        lcd_str1(mode);
        lcd_str2ve();
        break;  
   case btn_DEL_PRG:   // удаление программы
        if(VIEW1.count_prg==1)
          {
          lcd_message1("don't del all prg");
          lcd_str2ve();
          }
        else
          {
          for(int j=VIEW1.tek_prg;j<VIEW1.count_prg;j++)
            {
            get_prg_eeprom(j+1);
            put_prg_eeprom(j);
            }
          VIEW1.count_prg=VIEW1.count_prg-1;
          VIEW1.tek_prg=1;
          set_count_prg_eeprom(VIEW1.count_prg,VIEW1.tek_prg);
          get_prg_eeprom(1);
          lcd_message1("delete prg");
          lcd_str1(mode);
          lcd_str2ve();
          }
        break;  
   case btn_START:   // старт
        //
        mode=RUN_MODE;
        RUN1.tekrunprg=VIEW1.tek_prg;
        RUN1.steps=VIEW1.val[0]; 
        RUN1.step=VIEW1.val[1]; 
        RUN1.countstep=0;
        RUN1.speed=VIEW1.val[2];
        RUN1.direction=VIEW1.val[3];
        RUN1.tekdirection=VIEW1.val[3];
        RUN1.circles=VIEW1.val[4];
        RUN1.tekcircle=0; 
        if(RUN1.circles>0)
           RUN1.dtekcircle=1;
        else
           RUN1.dtekcircle=0;       
        RUN1.photo=VIEW1.val[5];
        RUN1.stopphoto=VIEW1.val[6];
        RUN1.pause=VIEW1.val[8];
        RUN1.statuspause=0;
        RUN1.millispause=millis();       
        lcd_str1(mode);
        lcd_str2run();
        
        
        stepper1.setSpeed(0);
        stepper1.setCurrentPosition(0);
        if(RUN1.stopphoto>0)
          delay(RUN1.pause);
        stepper1.setSpeed(RUN1.speed*kdirs[RUN1.tekdirection]);
        stepper1.moveTo(min(RUN1.steps,RUN1.step)*K1*kdirs[RUN1.tekdirection]); 
        Serial.println(RUN1.speed);
        Serial.println(RUN1.step*K1);
        
        break;  
   case btn_CALIB:   // запуск калибровки текущей программы
        mode=CALIB_MODE;lcd_str1(mode);
        stepper1.setCurrentPosition(0);
        stepper1.setSpeed(VIEW1.val[2]*kdirs[VIEW1.val[3]]);
        stepper1.moveTo(kdirs[VIEW1.val[3]]*100000); 
        break;  
   default:
        break;  
   }
 } 
// режим редактирования
void do_for_key2(int kod)
 {
 switch(kod)
   {
   case btn_VIEW_EDIT_RUN:   // вход в режим просмотра программы
        mode=RUN_MODE;lcd_str1(mode);
        //lcd_str2ve();
        break;  
   case btn_NEXT_PRG:   // следующая программа
        VIEW1.tek_prg=max((VIEW1.tek_prg+1)%(VIEW1.count_prg+1),1);
        //VIEW1.tek_prg=min(VIEW1.tek_prg+1,VIEW1.count_prg);
        get_prg_eeprom(VIEW1.tek_prg);
        //VIEW1.pos_prg=0;
        lcd_str1(mode);lcd_str2ve();
        break;  
   case btn_PREV_PRG:   // предыдущая программы
        VIEW1.tek_prg=VIEW1.tek_prg-1;
        if(VIEW1.tek_prg==0)
           VIEW1.tek_prg=VIEW1.count_prg;
        get_prg_eeprom(VIEW1.tek_prg);
        //VIEW1.pos_prg=0;
        lcd_str1(mode);lcd_str2ve();
        break;  
   case btn_NEXT_POS:   // следующий параметр текущей программы
        VIEW1.pos_prg=(VIEW1.pos_prg+1)%9;
        lcd_str2ve();
        break;  
   case btn_PREV_POS:   // предыдущий параметр текущей программы
        VIEW1.pos_prg=(VIEW1.pos_prg+9-1)%9;
        lcd_str2ve();
        break;  
   case btn_VAL_PLUS:   // увеличение параметра текущей программы
        VIEW1.val[VIEW1.pos_prg]=(VIEW1.val[VIEW1.pos_prg]+stepvalue[VIEW1.pos_prg])%maxvalue[VIEW1.pos_prg];
        //VIEW1.val[VIEW1.pos_prg]=min(VIEW1.val[VIEW1.pos_prg],maxvalue[VIEW1.pos_prg]);
        lcd_str2ve();
        break;  
   case btn_VAL_MINUS:   // уменьшение параметра текущей программы
        VIEW1.val[VIEW1.pos_prg]=(VIEW1.val[VIEW1.pos_prg]-stepvalue[VIEW1.pos_prg]+maxvalue[VIEW1.pos_prg])%maxvalue[VIEW1.pos_prg];
        //VIEW1.val[VIEW1.pos_prg]=max(VIEW1.val[VIEW1.pos_prg],minvalue[VIEW1.pos_prg]);
        lcd_str2ve();
        break;  
   case btn_EDIT_OK:   // сохранения параметров текущей программы
        put_prg_eeprom(VIEW1.tek_prg);
        lcd_message1("new params load");
        lcd_str2ve();
        break;  
   case btn_EDIT_ESC:   // не сохраненять измененные параметры текущей программы
        get_prg_eeprom(VIEW1.tek_prg);
        lcd_message1("old params load");
        lcd_str2ve();
        break;  
   default:
        break;  
   } 
 } 
// режим выполнения программы
void do_for_key3(int kod)
 {
  switch(kod)
   {
   case btn_END_RUN:   // выход из выполнения 
                       // вход в режим просмотра
        stepper1.setSpeed(0);
        stepper1.setCurrentPosition(0);
        RUN1.tekrunprg=0;
        mode=VIEW_MODE;lcd_str1(mode);lcd_str2ve();
        break;  
   case btn_FON_RUN:   // фоновое выполнение 
                       // вход в режим просмотра программы
        mode=VIEW_MODE;lcd_str1(mode);lcd_str2ve();
        break;  
   default:
        break;  
   }
 } 
// режим калибровки
void do_for_key4(int kod)
 {
  switch(kod)
   {
   case btn_END_CALIB:   // выход из калибровки 
                       // вход в режим просмотра
        K1=abs(stepper1.currentPosition()/360);
        Serial.print("K1=");
        Serial.println(K1);               
        stepper1.setSpeed(0);
        stepper1.setCurrentPosition(0);
        mode=VIEW_MODE;lcd_str1(mode);
        lcd.setCursor(0,1);lcd.print("               ");
        lcd.setCursor(0,1);lcd.print("k1=");
        lcd.setCursor(3,1);lcd.print(K1);
        //lcd_str2ve();
        break;  
   default:
        break;  
   }
 } 

