// очистка EEPROM - первый запуск
void clear_eeprom()
 {
 for(int i=0;i<512;i++)
   EEPROM.write(i,0);
 } 
// запись в EEPROM при создании новой программы
void ini_eeprom(int prg)
 {
 EEPROM.write(0,prg);
 EEPROM.write(1,prg);
 EEPROM.write(prg*20+1,0);EEPROM.write(prg*20+2,200);
 EEPROM.write(prg*20+3,0);EEPROM.write(prg*20+4,200);
 EEPROM.write(prg*20+5,0);EEPROM.write(prg*20+6,100);
 EEPROM.write(prg*20+7,0);EEPROM.write(prg*20+8,0);
 EEPROM.write(prg*20+9,0);EEPROM.write(prg*20+10,5);
 EEPROM.write(prg*20+11,0);EEPROM.write(prg*20+12,0);
 EEPROM.write(prg*20+13,0);EEPROM.write(prg*20+14,0);
 EEPROM.write(prg*20+15,0);EEPROM.write(prg*20+16,0);
 EEPROM.write(prg*20+17,0);EEPROM.write(prg*20+18,0);
 EEPROM.write(prg*20+19,0);EEPROM.write(prg*20+20,0);
 } 
// получить количество программ и текущую
void get_param_prg_eeprom(int tek_prg)
 {
 int i;
 VIEW1.count_prg=EEPROM.read(0);
 if(tek_prg==0)
   VIEW1.tek_prg=EEPROM.read(1);
 else
   VIEW1.tek_prg=tek_prg;
 if(VIEW1.tek_prg>0)   
   {
   for(i=0;i<10;i++)
     VIEW1.val[i]=(EEPROM.read(VIEW1.tek_prg*20+i*2+1)<<8)+EEPROM.read(VIEW1.tek_prg*20+i*2+2);
   }
 }    
// записать количество программ и текущую
void set_count_prg_eeprom(int count_prg,int tek_prg)
 {
 EEPROM.write(0,count_prg);  
 EEPROM.write(1,tek_prg);  
 } 
// загрузить значения для выбранной программы
void get_prg_eeprom(int prg)
 {
 for(int i=0;i<10;i++)
   {
   VIEW1.val[i]=(EEPROM.read(prg*20+1+i*2)<<8)+EEPROM.read(prg*20+2+i*2);  
   //Serial.print(prg*20+i*2);Serial.print("=");Serial.println(VIEW1.val[i]);
   }
 }
// записать значения выбранной программы в память
void put_prg_eeprom(int prg)
 {
 for(int i=0;i<10;i++)
   {
   EEPROM.write(prg*20+1+i*2,highByte(VIEW1.val[i]));  
   EEPROM.write(prg*20+2+i*2,lowByte(VIEW1.val[i]));  
   }
 }
